import { IMiddleware } from '@midwayjs/core';
import { Middleware, App } from '@midwayjs/decorator';
import { NextFunction, Context, Application } from '@midwayjs/koa';
import { VOBase } from '../interface/VOBase';
import _ = require('lodash');
@Middleware()
export class ResponseMiddleware implements IMiddleware<Context, NextFunction> {
  @App()
  app: Application;
  resolve() {
    return async (ctx: Context, next: NextFunction) => {
      await next();
      // 过滤掉 api文档的请求
      const swaggerPath = this.app.getConfig()?.swagger?.swaggerPath;
      const url = _.get(ctx, 'request.originalUrl');
      if (!url.includes(swaggerPath)) {
        const response = ctx.response;
        const body = response.body;
        const nb = new VOBase(body as object);
        return nb;
      }
    };
  }

  static getName(): string {
    return 'response';
  }
}
